#include <system.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "button_lib.h"
#include "LCD_lib.h"
#include "A2DConv.h"
#include "generator_commands.h"
#include "GPS_parse_lib.h"

//Button Press Bits//
volatile bit int2ie@INTCON3.4;
volatile bit int2if@INTCON3.1;
volatile bit intedg2@INTCON2.4;
volatile bit button1@PORTB.1;
volatile bit button0@PORTB.0;

//Button Press variables//
int count;
unsigned short debounce;
int disp;
int chargetime;
int totaltime;
int begin;
//Display variables//
unsigned short dispcurrent1;
unsigned short dispcurrent2;
unsigned char dispucvolts;
int dispspeed;
int disppower;
int dispdecimal;
int displayspeed;

void button_init(void)
{
	trisb.0 = 1;
	trisb.1 = 1;

	count = 1000;
	disp = 0;
	begin = 0;
	chargetime = 0;
	return;
}
void button2_init(void)
{
	trisb.2 = 1;
	int2ie = 1;
	intedg2 = 1;
	int2if = 0;
	return;
}
//What to display on LCD when button is pressed//
void display(void)
{latd=56;
	disp = count % 8;
	switch (disp)
	{
		case 0: 
			LCD_clear();
			dispucvolts = ultracap_voltage2();
			LCD_printf(" Ultracap Voltage");
			LCD_cursor(0x46);
			LCD_voltage(dispucvolts);
			LCD_printf(" V");
			break;
		case 1:
			LCD_clear();
			LCD_printf("  Power Consumption");
			dispucvolts = ultracap_voltage2();
			dispcurrent2 = current_out();
			int volts; 
			int current;
			volts = dispucvolts;
			dispucvolts = dispucvolts*15400;
			dispucvolts =dispucvolts/425;
			current = dispcurrent2;
			int power;
			power = current*volts;		
			LCD_current(power);
			break;
		case 2:
			LCD_clear();
			dispcurrent1 = current_in();
			dispcurrent2 = current_out();
			LCD_printf("Current In: ");
			LCD_current(dispcurrent1);
			LCD_printf("000.00 A");	
			LCD_cursor(0x14);
			LCD_printf("Current Out: ");
			LCD_current(dispcurrent2);
			LCD_printf("A");	
			break;
		case 3: 
			LCD_clear();
			LCD_printf("Speed");
			LCD_cursor(0x45);
			LCD_speed();
			break;
		case 4:
			LCD_clear();
			LCD_printLon();
			break;
		case 5:
			LCD_clear();
			LCD_printLat();
			break;
		case 6:
			LCD_clear();
			LCD_printf("   Output Signals");
			LCD_cursor(0x40);
			if (latb.3==1) LCD_printf("     Starter On");
			if (latb.3==0) LCD_printf("    Starter Off");
			LCD_cursor(0x14);
			if (latb.4==1) LCD_printf("   Fuel Valve On");
			if (latb.4==0) LCD_printf("   Fuel Valve Off");
			LCD_cursor(0x54);
			if (late.0==1) LCD_printf("    Glow Plug On");
			if (late.0==0) LCD_printf("   Glow Plug Off");
			break;
		case 7:
			LCD_clear();
			LCD_printf("Charge Time:")
			LCD_cursor(0x40);
			char percentdisp;
			percentdisp = chargetime_disp();
			LCD_dec(percentdisp);
			LCD_printf(" %");
			break;
		default: 
			LCD_clear();
			LCD_printf("DEEFAWLT");
			break;
	}
	if (count == 0)
		count = 1000;
	return;
}
void charge_time(int tmr0countval)
{
	chargetime++;
	totaltime = tmr0countval;
	return;
}
char chargetime_disp(void)
{
	chargetime = chargetime*100;
	chargetime = chargetime/totaltime;
	char percent;
	percent = chargetime;
	return percent;
}
int debounce3(void)
{
	while(debounce <1000)
	{
		debounce++;
	}
		debounce = 0;
	begin = 1;
	return begin;	
}

void checkbuttons(void)
{
	if (button1 == 1)
	{
		delay_ms(40);
		if (button1==1)
		{
			count++;
			display();
		}
	}
	if (button0 == 1)
	{
		delay_ms(40);
		if (button0==1)
		{
			count--;
			display();
		}
	}
	return;
}