#include <system.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "button_lib.h"
#include "LCD_lib.h"
#include "A2DConv.h"
#include "generator_commands.h"
#include "GPS_parse_lib.h"

//Generator Signals//
volatile bit starter@LATB.3;
volatile bit fuelvalve@LATB.4;
volatile bit glowplug@LATE.0;

unsigned char ucvoltage;
unsigned char gen_signal;

void gen_commands_init(void)
{
	trisb.3 = 0;
	trisb.4 = 0;
	trise.0 = 0;
	starter = 0;
	fuelvalve = 0;
	glowplug = 0;
	return;
}
//Start the Charging Cycle//
void start_charge(void)
{
	fuelvalve = 1;
	starter =1;
	return;
}
//Check to See if Generator is On and Turn off Starter//
void check_starter(void)
{
	while (starter == 1)
	{
		checkbuttons();
		gen_signal = gen_output();			//check to see if generator is outputting voltage
		delay_ms(10);
		if (gen_signal > 220)	//if generator is outputting voltage, starter can be turned off
			starter = 0;
	}
	return;
}
//Check Ultracaps and Turn off Generator if Charging is Finished//
void monitor_ultracaps(int monitor_ultracaps)
{
	while (monitor_ultracaps == 1)
	{
		ucvoltage = ultracap_voltage();
		if (ucvoltage > 208)		//if ultracaps above threshold, stop charging
		{
			fuelvalve = 0; starter = 0; //turn off all signals
			monitor_ultracaps = 0;		//exit checking/charging loop		
		}
	}
	return;
}